# Idioms

[Idioms](https://en.wikipedia.org/wiki/Programming_idiom) are commonly used
styles and patterns largely agreed upon by a community. They are guidelines.
Writing idiomatic code allows other developers to understand what is happening
because they are familiar with the form that it has.

The computer understands the machine code that is generated by the compiler.
The language is therefore mostly beneficial to the developer.
So, since we have this abstraction layer, why not put it to good use and make
it simple?

Remember the [KISS principle](https://en.wikipedia.org/wiki/KISS_principle):
"Keep It Simple, Stupid". It claims that "most systems work best if they are
kept simple rather than made complicated; therefore, simplicity should be a key
goal in design, and unnecessary complexity should be avoided".

> Code is there for humans, not computers, to understand.
